<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Admin extends CI_Controller
{

	public function __construct()
	{
		parent:: __construct();
		$this->load->Model('Model');
		$this->load->Model('Token');
	}

	public function login()
	{
		if ($this->input->get_request_header('APP-PUBLIC-TOKEN', true) != APP_PUBLIC_TOKEN) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}

		$data['aUsName'] = $this->input->post('aUsName');
		$data['aPwd'] = sha1($this->input->post('aPwd'));

		$where = array("aUsName" => $data['aUsName'], "aPwd" => $data['aPwd']);
		$this->db->where($where);
		$query = $this->db->get('admin');
		$count_row = $query->num_rows();

		if ($count_row != 1 || $count_row == 0) {

			$response = array(
				'responsecode' => '200',
				'status' => 'fail',
				'message' => "User not registered"
			);

		} else {
			$adminData = $query->row_array();

			$tokenData['aToken'] = sha1(random_string('md5', 100));

			date_default_timezone_set("Asia/Kolkata");
			$tokenData['auDate'] = date("Y-m-d h:i:s");
			$tokenData['aFcmId'] = $this->input->post('aFcmId');

			$this->db->where('aUsName', $adminData['aUsName']);
			$this->db->update('admin', $tokenData);

			if ($this->db->affected_rows() != 1) {

				//print_r($this->db->affected_rows());
				$response = array(
					'responsecode' => '200',
					'status' => 'tokenerror',
					'message' => "Unable to process request token"
				);

			} elseif ($this->db->affected_rows() == 1) {

				$adminData['aFcmId'] = $tokenData['aFcmId'];
				$adminData['aToken'] = $tokenData['aToken'];
				$adminData['auDate'] = $tokenData['auDate'];
				$adminData['aPwd'] = "";

//				echo '<pre>';
//				print_r($tokenData);

				$response = array(
					'responsecode' => '200',
					'status' => 'token-created',
					'message' => "Access token generated successfully",
					'adminDetail' => $adminData
				);

			}

		}

		$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')
			->set_header('Cache-Control: post-check=0, pre-check=0')
			->set_header('Pragma: no-cache')->set_status_header(200)
			->set_content_type('application/json', 'utf-8')
			->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
		exit;

	}

	public function getStd()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['std'] = $this->Model->select_all_order("standard", 'stId', 'asc');

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'std' => $data['std']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getDiv()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$stFk = $this->input->post('stFk');

			$where = array("stFk" => $stFk);
			//$data['div'] = $this->Model->select_all("division", $where);
			$data['div'] = $this->Model->join_where_order("division", "standard", '`division`.`stFk` = `standard`.`stId`', $where, 'sdDiv', 'asc');

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'div' => $data['div']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getStdDivSchool()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['school'] = $this->Model->select_all("school");
			$data['std'] = $this->Model->select_all("standard");
			$data['div'] = $this->Model->select_all("division");

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'school' => $data['school'],
				'std' => $data['std'],
				'div' => $data['div']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addStd()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['scFk'] = $this->input->post('scFk');
			$data['sStd'] = $this->input->post('sStd');

			$insStdDiv = $this->Model->insert("standard", $data);

			if ($insStdDiv) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Standard added successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to add standard."
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addDiv()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['stFk'] = $this->input->post('stFk');
			$data['sdDiv'] = $this->input->post('sdDiv');

			$insDiv = $this->Model->insert("division", $data);

			if ($insDiv) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Division added successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to add division."
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getStdDivSub()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			//$data['stddivsub'] = $this->Model->join_three("subject", "division", "standard", '`division`.`stFk` = `standard`.`stId`', '`subject`.`stFk` = `standard`.`stId`');

			$data['std'] = $this->Model->select_all_order("standard", 'stId', 'asc');
			$data['div'] = $this->Model->select_all_order("division", 'sdDiv', 'asc');
			$data['subject'] = $this->Model->select_all("subject");

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'std' => $data['std'],
				'div' => $data['div'],
				'subject' => $data['subject']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getSubject()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$admNo = $this->input->post('sAdmNo');
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == STYPE) {
			if ($this->Token->checkStudentToken($token, $admNo) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['stFk'] = $this->input->post('stFk');

			$where = array("stFk" => $data['stFk']);
			$data['subject'] = $this->Model->join_where("subject", "standard", '`standard`.`stId`=`subject`.`stFk`', $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'subject' => $data['subject']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getSubTeacher()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['stFk'] = $this->input->post('stFk');

			$where = array("stFk" => $data['stFk']);
			$data['subject'] = $this->Model->select_where("subject", $where);
			$data['dvFk'] = $this->input->post('dvFk');
			$where = array("tActive" => '1', "asgnStd" => $data['stFk'], "asgnDiv" => $data['dvFk']);
			$data['assignteacher'] = $this->Model->join_custom_where('`ast`.`tFk` = `tchr`.`tUsName`', $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'subject' => $data['subject'],
				'assignteacher' => $data['assignteacher']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addSubject()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$type = $this->input->post('type');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['stFk'] = $this->input->post('stFk');
			$data['sbCode'] = $this->input->post('sbCode');
			$data['sbName'] = $this->input->post('sbName');

			if ($type == UTYPE) {
				$data['sbId'] = $this->input->post('sbId');
				$where = array("sbId" => $data['sbId']);
				$insSub = $this->Model->update("subject", $data, $where);
			} else {
				$insSub = $this->Model->insert("subject", $data);
			}

			if ($insSub) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Subject " . $type . " successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to " . $type . " subject."
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getAllTeacher()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$where = array("tActive" => '1');
			$data['teacher'] = $this->Model->select_where("teacher", $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'teacher' => $data['teacher']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getTeacher()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$where = array("tActive" => '1', "tUsName" => $tUsName);
			$data['teacher'] = $this->Model->join_three_where_row("teacher", "standard", "division", '`teacher`.`stFk` = `standard`.`stId`', '`teacher`.`dvFk` = `division`.`dId`', $where);

			if ($data['teacher'] == NULL) {
				$data['teacher'] = $this->Model->select_where_row("teacher", $where);
			}

			$where = array("tFk" => $tUsName);
			$data['assignteacher'] = $this->Model->join_four_where_order("assignteacher", "standard", "division", "subject", "`standard`.`stId` = `assignteacher`.`asgnStd`", "`division`.`dId` = `assignteacher`.`asgnDiv`", "`subject`.`sbId` = `assignteacher`.`asgnSub`", $where, 'asgnStd', 'asc');

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'teacher' => $data['teacher'],
				'assignteacher' => $data['assignteacher']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addTeacher()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$type = $this->input->post('type');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['scFk'] = $this->input->post('scFk');
			$data['tName'] = $this->input->post('tName');
			$data['stFk'] = $this->input->post('stFk');
			$data['dvFk'] = $this->input->post('dvFk');
			$data['tMob'] = $this->input->post('tMob');
			$data['tUsName'] = $this->input->post('tUsName');
			$data['tGender'] = $this->input->post('tGender');
			$data['tPwd'] = sha1($data['tMob']);
			$data['tEmail'] = $this->input->post('tEmail');
			$data['tEdu'] = $this->input->post('tEdu');
			$data['tJoining'] = $this->input->post('tJoining');
			$data['tAdrs'] = $this->input->post('tAdrs');
			$data['tActive'] = '1';
			date_default_timezone_set("Asia/Kolkata");

			if ($type == UTYPE) {
				$data['tuDate'] = date("Y-m-d h:i:s");
				$where = array("tUsName" => $data['tUsName']);
				$insTeacher = $this->Model->update("teacher", $data, $where);
			} else {
				$data['tcDate'] = date("Y-m-d h:i:s");
				$data['tuDate'] = $data['tcDate'];
				$insTeacher = $this->Model->insert("teacher", $data);
			}

			if ($insTeacher) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Teacher " . $type . " successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to " . $type . " teacher."
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function assignTeacher()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['tFk'] = $this->input->post('tUsName');
			$data['asgnStd'] = $this->input->post('asgnStd');
			$data['asgnDiv'] = $this->input->post('asgnDiv');
			$data['asgnSub'] = $this->input->post('asgnSub');

			$asgnTeacher = $this->Model->insert("assignteacher", $data);

			if ($asgnTeacher) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Teacher assign successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to assign teacher."
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getTransport()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['scFk'] = $this->input->post('scFk');

			$where = array("trActive" => '1', "scFk" => $data['scFk']);
			$data['transport'] = $this->Model->select_where("transport", $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'transport' => $data['transport']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addTransport()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$type = $this->input->post('type');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['scFk'] = $this->input->post('scFk');
			$data['trRNo'] = $this->input->post('trRNo');
			$data['trDName'] = $this->input->post('trDName');
			$data['trDMob'] = $this->input->post('trDMob');
			$data['trDBusNo'] = $this->input->post('trDBusNo');
			$data['trActive'] = '1';

			date_default_timezone_set("Asia/Kolkata");

			if ($type == UTYPE) {
				$data['trId'] = $this->input->post('trId');
				$data['truDate'] = date("Y-m-d h:i:s");
				$where = array("trId" => $data['trId']);
				$insTr = $this->Model->update("transport", $data, $where);
			} else {
				$data['trcDate'] = date("Y-m-d h:i:s");
				$data['truDate'] = $data['trcDate'];
				$insTr = $this->Model->insert("transport", $data);
			}

			if ($insTr) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Transport detail " . $type . " successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to " . $type . " transport detail"
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getTimeTable()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['stFk'] = $this->input->post('stFk');
			$data['dvFk'] = $this->input->post('dvFk');

			$where = array("ttActive" => '1', "tstFk" => $data['stFk'], "tdvFk" => $data['dvFk']);
			$data['timetable'] = $this->Model->join_three_where("timetable", "teacher", "subject", ' `timetable`.`tFk` = `teacher`.`tUsName` ', ' `timetable`.`sbFk` = `subject`.`sbId` ', $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'timetable' => $data['timetable']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addTimeTable()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');
		$cType = $this->input->post('cType');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['scFk'] = $this->input->post('scFk');
			$data['tstFk'] = $this->input->post('stFk');
			$data['tdvFk'] = $this->input->post('dvFk');
			$data['tFk'] = $this->input->post('tFk');
			$data['sbFk'] = $this->input->post('sbFk');
			$data['ttLNo'] = $this->input->post('ttLNo');
			$data['ttDay'] = $this->input->post('ttDay');
			$data['ttYear'] = $this->input->post('ttYear');

			date_default_timezone_set("Asia/Kolkata");

			if ($cType == UTYPE) {
				$data['ttId'] = $this->input->post('ttId');
				$data['ttuDate'] = date("Y-m-d h:i:s");
				$where = array("ttId" => $data['ttId']);
				$insTr = $this->Model->update("timetable", $data, $where);
			} else {
				$data['ttcDate'] = date("Y-m-d h:i:s");
				$data['ttuDate'] = $data['ttcDate'];
				$insTr = $this->Model->insert("timetable", $data);
			}

			if ($insTr) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Time-Table " . $cType . " successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to " . $cType . " time-table"
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getFeeStructure()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$limit = $this->input->post('limit');
			$offset = $this->input->post('offset');

			$data['feestructure'] = $this->Model->join_order_limit("feestructure", "standard", ' `feestructure`.`stFk` = `standard`.`stId` ', 'sStd', 'asc', $limit, $offset);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'feestructure' => $data['feestructure']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addFeeStructure()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$type = $this->input->post('type');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['scFk'] = $this->input->post('scFk');
			$data['stFk'] = $this->input->post('stFk');
			$data['fMonth'] = $this->input->post('fMonth');
			$data['fTutFee'] = $this->input->post('fTutFee');
			$data['fCompFee'] = $this->input->post('fCompFee');
			$data['fTechFee'] = $this->input->post('fTechFee');
			$data['fSciFee'] = $this->input->post('fSciFee');
			$data['fBusFee'] = $this->input->post('fBusFee');
			$data['fRquisite'] = $this->input->post('fRquisite');
			$data['fTotal'] = $data['fTutFee'] + $data['fCompFee'] + $data['fTechFee'] + $data['fRquisite'] + $data['fSciFee'];

			date_default_timezone_set("Asia/Kolkata");

			if ($type == UTYPE) {
				$fId = $this->input->post('fId');
				$data['fuDate'] = date("Y-m-d h:i:s");
				$where = array("fId" => $fId);
				$insFee = $this->Model->update("feestructure", $data, $where);
			} else {
				$data['fcDate'] = date("Y-m-d h:i:s");
				$data['fuDate'] = $data['fcDate'];
				$insFee = $this->Model->insert("feestructure", $data);
			}

			if ($insFee) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Fee structure added successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to add fee structure"
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getStudentFee()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$limit = $this->input->post('limit');
			$offset = $this->input->post('offset');

			$data['allstudentfee'] = $this->Model->join_three_order_limit("feestudent", "student", "standard", ' `feestudent`.`sFk` = `student`.`sAdmNo` ', ' `feestudent`.`fstFk` = `standard`.`stId` ', 'fscDate', 'desc', $limit, $offset);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'allstudentfee' => $data['allstudentfee']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addFee()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$feeData = $this->input->post('feeData[]');

			$fData = json_decode($feeData);

			date_default_timezone_set("Asia/Kolkata");

			$data['fscDate'] = date("Y-m-d h:i:s");

			$value = array();
			foreach ($fData as $res) {
				array_push($value, array(
					"fFk" => $res->fFk,
					"sFk" => $res->sFk,
					"fstFk" => $res->fstFk,
					"fdvFk" => $res->dvFk,
					"fsTotal" => $res->fsTotal,
					"fsMonth" => $res->fsMonth,
					"fsMonPrice" => $res->fsMonPrice,
					"fsPaymentId" => $res->fsPaymentId,
					"fsPayType" => $res->fsPayType,
					"fsBus" => $res->fsBus,
					"fscDate" => $data['fscDate']
				));
			}

			$insFee = $this->Model->insert_batch("feestudent", $value);

			if ($insFee) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Fees paid successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to paid fees"
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getAdmin()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$where = array("aActive" => '1', "aUsName" => $aUsName);
			$data['admin'] = $this->Model->select_where_row("admin", $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'admin' => $data['admin']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function updateAdmin()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['aId'] = $this->input->post('aId');
			$data['aName'] = $this->input->post('aName');
			$data['aMob'] = $this->input->post('aMob');
			$data['aEmail'] = $this->input->post('aEmail');
			$data['aAdrs'] = $this->input->post('aAdrs');

			date_default_timezone_set("Asia/Kolkata");

			$data['auDate'] = date("Y-m-d h:i:s");

			$where = array("aUsName" => $data['aUsName']);
			$updtAdmin = $this->Model->update("admin", $data, $where);

			if ($updtAdmin) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Admin updated successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to update admin"
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getFeeStudentStructure()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$admNo = $this->input->post('sAdmNo');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == STYPE) {
			if ($this->Token->checkStudentToken($token, $admNo) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['stFk'] = $this->input->post('stFk');

			$where = array("sAdmNo" => $admNo, "fstFk" => $data['stFk']);
			$data['feestudent'] = $this->Model->join_three_where("feestudent", "student", "standard", "`student`.`sAdmNo` = `feestudent`.`sFk`", "`standard`.`stId` = `feestudent`.`fstFk`", $where);
			$where = array("stFk" => $data['stFk']);
			$data['feestructure'] = $this->Model->join_where("feestructure", "standard", ' `standard`.`stId` = `feestructure`.`stFk` ', $where);
			$where = array("sActive" => '1', "sAdmNo" => $admNo);
			$data['student'] = $this->Model->select_where_row("student", $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'feestudent' => $data['feestudent'],
				'feestructure' => $data['feestructure'],
				'student' => $data['student']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addEvent()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$type = $this->input->post('type');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			if (!empty($_FILES['eDoc']['name'])) {

				$_FILES['file']['name'] = $_FILES['eDoc']['name'];
				$_FILES['file']['type'] = $_FILES['eDoc']['type'];
				$_FILES['file']['tmp_name'] = $_FILES['eDoc']['tmp_name'];
				$_FILES['file']['error'] = $_FILES['eDoc']['error'];
				$_FILES['file']['size'] = $_FILES['eDoc']['size'];

				$config['upload_path'] = './upload/event/';

				$config['allowed_types'] = $config['allowed_types'] = 'pdf|pptx|ppt|xlsx|xls|docx|doc|txt|jpeg|jpg|png';;
				$config['remove_spaces'] = TRUE;
				$config['encrypt_name'] = TRUE;

				$this->load->library('upload', $config);
				$this->upload->initialize($config);

				if (!is_dir($config['upload_path'])) {
					mkdir($config['upload_path'], 0777, TRUE);
				}

				if (file_exists($config['upload_path'] . $_FILES['file']['name'])) {

					unlink($config['upload_path'] . $_FILES['file']['name']);

				}

				if ($this->upload->do_upload('file')) {
					// Uploaded file data
					$upload_data = $this->upload->data();

					$data['eDoc'] = $upload_data['file_name'];

				}

			}

			$data['escFk'] = $this->input->post('scFk');
			$data['eTitle'] = $this->input->post('eTitle');
			$data['eDate'] = $this->input->post('eDate');
			$data['eDesc'] = $this->input->post('eDesc');

			date_default_timezone_set("Asia/Kolkata");

			if ($type == UTYPE) {
				$data['eId'] = $this->input->post('eId');
				$data['euDate'] = date("d-m-yy");
				$where = array("eId" => $data['eId']);
				$insert = $this->Model->update("event", $data, $where);
			} else {
				$data['ecDate'] = date("d-m-yy");
				$data['euDate'] = $data['ecDate'];
				$insert = $this->Model->insert('event', $data);
			}

			if ($insert) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Event " . $type . " successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to " . $type . " event."
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getEvent()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$admNo = $this->input->post('sAdmNo');
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == STYPE) {
			if ($this->Token->checkStudentToken($token, $admNo) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['eId'] = $this->input->post('eId');

			$where = array("eId" => $data['eId']);
			$data['event'] = $this->Model->select_where_row("event", $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'event' => $data['event']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getAllEvent()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$admNo = $this->input->post('sAdmNo');
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == STYPE) {
			if ($this->Token->checkStudentToken($token, $admNo) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['event'] = $this->Model->select_all_order("event", 'ecDate', 'desc');

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'event' => $data['event']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addCircular()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$type = $this->input->post('type');

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			if (!empty($_FILES['cDoc']['name'])) {

				$_FILES['file']['name'] = $_FILES['cDoc']['name'];
				$_FILES['file']['type'] = $_FILES['cDoc']['type'];
				$_FILES['file']['tmp_name'] = $_FILES['cDoc']['tmp_name'];
				$_FILES['file']['error'] = $_FILES['cDoc']['error'];
				$_FILES['file']['size'] = $_FILES['cDoc']['size'];

				$config['upload_path'] = './upload/circular/';

				$config['allowed_types'] = 'pdf|pptx|ppt|xlsx|xls|docx|doc|txt|jpeg|jpg|png';
				$config['remove_spaces'] = TRUE;
				$config['encrypt_name'] = TRUE;

				$this->load->library('upload', $config);
				$this->upload->initialize($config);

				if (!is_dir($config['upload_path'])) {
					mkdir($config['upload_path'], 0777, TRUE);
				}

				if (file_exists($config['upload_path'] . $_FILES['file']['name'])) {

					unlink($config['upload_path'] . $_FILES['file']['name']);

				}

				if ($this->upload->do_upload('file')) {
					// Uploaded file data
					$upload_data = $this->upload->data();

					$data['cDoc'] = $upload_data['file_name'];

				}
			}

			$data['cscFk'] = $this->input->post('scFk');
			$data['cstFk'] = $this->input->post('cstFk');
			$data['cdvFk'] = $this->input->post('cdvFk');
			$data['cTitle'] = $this->input->post('cTitle');
			$data['cDesc'] = $this->input->post('cDesc');
			$data['cFor'] = $this->input->post('cFor');

			date_default_timezone_set("Asia/Kolkata");

			if ($type == UTYPE) {
				$data['cId'] = $this->input->post('cId');
				$data['cuDate'] = date("d-m-yy");
				$where = array("cId" => $data['cId']);
				$insert = $this->Model->update("circular", $data, $where);
			} else {
				$data['ccDate'] = date("d-m-yy");
				$data['cuDate'] = $data['ccDate'];
				$insert = $this->Model->insert('circular', $data);
			}

			if ($insert) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Circular " . $type . " successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to " . $type . " circular."
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getCircular()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$admNo = $this->input->post('sAdmNo');
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == STYPE) {
			if ($this->Token->checkStudentToken($token, $admNo) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['cId'] = $this->input->post('cId');

			$where = array("cId" => $data['cId']);
			$data['circular'] = $this->Model->select_where_row("circular", $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'circular' => $data['circular']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getAllCircular()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$admNo = $this->input->post('sAdmNo');
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == STYPE) {
			if ($this->Token->checkStudentToken($token, $admNo) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['circular'] = $this->Model->select_all_order("circular", 'ccDate', 'desc');

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'circular' => $data['circular']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addExamTerm()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');
		$cType = $this->input->post('cType');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['exscFk'] = $this->input->post('scFk');
			$data['exstFk'] = $this->input->post('stFk');
			$data['exdvFk'] = $this->input->post('dvFk');
			$data['exTerm'] = $this->input->post('exTerm');
			$data['exPMark'] = $this->input->post('exPMark');
			$data['exTMark'] = $this->input->post('exTMark');
			$data['exAddBy'] = $this->input->post('exAddBy');

			date_default_timezone_set("Asia/Kolkata");

			if ($cType == UTYPE) {
				$data['exId'] = $this->input->post('exId');
				$where = array("exId" => $data['exId']);
				$ins = $this->Model->update("examterm", $data, $where);
			} else {
				$data['excDate'] = date("d-m-yy");
				$ins = $this->Model->insert("examterm", $data);
			}

			if ($ins) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Exam term " . $cType . " successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to " . $cType . " exam term"
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addExamTable()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');
		$cType = $this->input->post('cType');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['etetFk'] = $this->input->post('etetFk');
			$data['etsbFk'] = $this->input->post('sbFk');
			$data['etDate'] = $this->input->post('etDate');
			$data['etTime'] = $this->input->post('etTime');

			date_default_timezone_set("Asia/Kolkata");

			if ($cType == UTYPE) {
				$data['etId'] = $this->input->post('etId');
				$where = array("etId" => $data['etId']);
				$ins = $this->Model->update("examtable", $data, $where);
			} else {
				$data['etcDate'] = date("d-m-yy");
				$ins = $this->Model->insert("examtable", $data);
			}

			if ($ins) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Exam time table " . $cType . " successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to " . $cType . " exam time table"
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

}
