<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class AdminStudent extends CI_Controller
{

	public function __construct()
	{
		parent:: __construct();
		$this->load->Model('Model');
		$this->load->Model('Token');
	}

	public function addStudent()
	{
		$type = $this->input->post('type');
		$aUsName = $this->input->post('aUsName');
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);

		if ($this->Token->checkAdminToken($token, $aUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$student = $this->input->post('student');

			$studentData = json_decode($student);

			$data['scFk'] = $studentData->scFk;
			$data['stFk'] = $studentData->stFk;
			$data['dvFk'] = $studentData->dvFk;
			if (!empty($studentData->trFk)) {
				$data['trFk'] = $studentData->trFk;
			}
			$data['sName'] = $studentData->sName;
			$data['sRoll'] = $studentData->sRoll;
			$data['sAdmNo'] = $studentData->sAdmNo;
			$data['sPwd'] = sha1($data['sAdmNo']);
			if (!empty($studentData->sMob)) {
				$data['sMob'] = $studentData->sMob;
			}
			if (!empty($studentData->sEmail)) {
				$data['sEmail'] = $studentData->sEmail;
			}
			$data['sDOB'] = $studentData->sDOB;
			$data['sGender'] = $studentData->sGender;
			$data['sJoining'] = $studentData->sJoining;
			$data['sAdrs'] = $studentData->sAdrs;
			if (!empty($studentData->sBus)) {
				$data['sBus'] = $studentData->sBus;
			}
			if (!empty($studentData->sPickup)) {
				$data['sPickup'] = $studentData->sPickup;
			}
			$data['sActive'] = '1';
			date_default_timezone_set("Asia/Kolkata");

			if ($type == UTYPE) {
				$data['suDate'] = date("Y-m-d h:i:s");
				$where = array("sAdmNo" => $data['sAdmNo']);
				$sIns = $this->Model->update('student', $data, $where);
			} else {
				$data['scDate'] = date("Y-m-d h:i:s");
				$data['suDate'] = $data['scDate'];
				$sIns = $this->Model->insert('student', $data);
			}

			if ($sIns) {

				$parent = $this->input->post('parent');

				$parentData = json_decode($parent);

				$pdata['sFk'] = $data['sAdmNo'];
				if (!empty($parentData->pMName)) {
					$pdata['pMName'] = $parentData->pMName;
				}
				if (!empty($parentData->pMMob)) {
					$pdata['pMMob'] = $parentData->pMMob;
				}
				if (!empty($parentData->pMJob)) {
					$pdata['pMJob'] = $parentData->pMJob;
				}
				if (!empty($parentData->pFName)) {
					$pdata['pFName'] = $parentData->pFName;
				}
				if (!empty($parentData->pFMob)) {
					$pdata['pFMob'] = $parentData->pFMob;
				}
				if (!empty($parentData->pFJob)) {
					$pdata['pFJob'] = $parentData->pFJob;
				}

				if ($type == UTYPE) {
					$pdata['puDate'] = date("Y-m-d h:i:s");
					$where = array("sFk" => $data['sAdmNo']);
					$pIns = $this->Model->update('parents', $pdata, $where);
				} else {
					$pdata['pcDate'] = date("Y-m-d h:i:s");
					$pdata['puDate'] = $pdata['pcDate'];
					$pIns = $this->Model->insert('parents', $pdata);
				}

				if ($pIns) {

					$guardian = $this->input->post('guardian');

					$guardianData = json_decode($guardian);

					$gdata['sFk'] = $data['sAdmNo'];
					if (!empty($guardianData->gName)) {
						$gdata['gName'] = $guardianData->gName;
					}
					if (!empty($guardianData->gMob)) {
						$gdata['gMob'] = $guardianData->gMob;
					}
					if (!empty($guardianData->gEmail)) {
						$gdata['gEmail'] = $guardianData->gEmail;
					}
					if (!empty($guardianData->gRel)) {
						$gdata['gRel'] = $guardianData->gRel;
					}
					if (!empty($guardianData->gEdu)) {
						$gdata['gEdu'] = $guardianData->gEdu;
					}
					if (!empty($guardianData->gAdrs)) {
						$gdata['gAdrs'] = $guardianData->gAdrs;
					}

					if ($type == UTYPE) {
						$gdata['guDate'] = date("Y-m-d h:i:s");
						$where = array("sFk" => $data['sAdmNo']);
						$gIns = $this->Model->update('guardian', $gdata, $where);
					} else {
						$gdata['gcDate'] = date("Y-m-d h:i:s");
						$gdata['guDate'] = $gdata['gcDate'];
						$gIns = $this->Model->insert('guardian', $gdata);
					}

					if ($gIns) {
						$status = 'Success';
						$message = "Student " . $type . " successfully.";
					} else {
						$status = 'fail';
						$message = "Unable to " . $type . " guardian.";
					}

				} else {
					$status = 'fail';
					$message = "Unable to " . $type . " parents.";
				}

			} else {
				$status = 'fail';
				$message = "Unable to " . $type . " Student.";
			}

			$response = array(
				'responsecode' => '200',
				'status' => $status,
				'message' => $message
			);

		}

		$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
		exit;

	}

	public function getAllStudent()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['stFk'] = $this->input->post('stFk');
			$data['dvFk'] = $this->input->post('dvFk');

			$where = array("sActive" => '1', "stFk" => $data['stFk'], "dvFk" => $data['dvFk']);
			$data['student'] = $this->Model->select_where("student", $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'student' => $data['student']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getStudent()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$admNo = $this->input->post('sAdmNo');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == STYPE) {
			if ($this->Token->checkStudentToken($token, $admNo) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {


			$where = array("sActive" => '1', "sAdmNo" => $admNo);
			$data['student'] = $this->Model->join_five_where_row("student", "parents", "guardian", "standard", "division", ' `parents`.`sFk` = `student`.`sAdmNo` ', ' `guardian`.`sFk` = `student`.`sAdmNo` ', ' `standard`.`stId` = `student`.`stFk` ', ' `division`.`dId` = `student`.`dvFk` ', $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'student' => $data['student']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

}
