<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Common extends CI_Controller
{

	public function __construct()
	{
		parent:: __construct();
		$this->load->Model('Model');
		$this->load->Model('Token');
	}

	public function frgtPwd()
	{
		$type = $this->input->post('type');

		if ($this->input->get_request_header('APP-PUBLIC-TOKEN', true) != APP_PUBLIC_TOKEN) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			if ($type == ATYPE) {
				$where = array("aUsName" => $this->input->post('aUsName'));
				$data['aPwd'] = sha1($this->input->post('aPwd'));

				$updatePwd = $this->Model->update('admin', $data, $where);
			} elseif ($type == TTYPE) {
				$where = array("tUsName" => $this->input->post('tUsName'));
				$data['tPwd'] = sha1($this->input->post('tPwd'));

				$updatePwd = $this->Model->update('teacher', $data, $where);
			} elseif ($type == STYPE) {
				$where = array("sAdmNo" => $this->input->post('sAdmNo'));
				$data['sPwd'] = sha1($this->input->post('sPwd'));

				$updatePwd = $this->Model->update('student', $data, $where);
			}

			if ($this->db->affected_rows() != 1) {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Password could not be updated",

				);
			}
			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Password updated successfully",

			);
		}

		$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')
			->set_header('Cache-Control: post-check=0, pre-check=0')
			->set_header('Pragma: no-cache')->set_status_header(200)
			->set_content_type('application/json', 'utf-8')
			->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
		exit;

	}

	public function checkUserName()
	{
		$type = $this->input->post('type');

		if ($this->input->get_request_header('APP-PUBLIC-TOKEN', true) != APP_PUBLIC_TOKEN) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}

		if ($type == ATYPE) {
			$data['aUsName'] = $this->input->post('aUsName');
			$where = array("aActive" => '1', "aUsName" => $data['aUsName']);
			$this->db->where($where);
			$r = $this->db->get('admin');

		} elseif ($type == TTYPE) {
			$data['tUsName'] = $this->input->post('tUsName');
			$where = array("tActive" => '1', "tUsName" => $data['tUsName']);
			$this->db->where($where);
			$r = $this->db->get('teacher');

		} elseif ($type == STYPE) {
			$data['sAdmNo'] = $this->input->post('sAdmNo');
			$where = array("sActive" => '1', "sAdmNo" => $data['sAdmNo']);
			$this->db->where($where);
			$r = $this->db->get('student');

		}
		//$result = $r->result();
		$count_row = $r->num_rows();

		$response = array();
		if ($count_row == 1) {
			$row = $r->row_array();

			if ($type == ATYPE) {
				$mob = $row['aMob'];
			} elseif ($type == TTYPE) {
				$mob = $row['tMob'];
			} elseif ($type == STYPE) {
				$mob = $row['sMob'];
			}

			$otp = rand(1000, 9999);

			$response = array(
				'responsecode' => '200',
				'status' => 'success',
				'message' => "OTP send to Register Mobile Number",
				'otp' => $otp,
				'mobile' => $mob
			);

		} else {
			$response = array(
				'responsecode' => '200',
				'status' => 'fail',
				'message' => "Incorrect username"
			);

		}

		$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
		exit;
	}

	public function updatefcmId()
	{

		if (auth_user() == true) {

			$id = $this->input->post('uId');

			$data['fcmid'] = $this->input->post('fcmid');
			$data['token'] = sha1(random_string('md5', 100));

			date_default_timezone_set("Asia/Kolkata");
			$data['lastUpdatedDate'] = date("Y-m-d h:i:s");

			$result = $this->UserUpdateModel->update("users", $data, $id);

			$response = array();

			if ($result == 'notupdated') {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "FcmId Could not be updated"

				);
			} else if ($result == 'updated') {

				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "FcmId Updated Successfully"

				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Something Went Wrong"

				);
			}


			print_json($response);
			exit;

		} else {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'

			);
			print_json($response);
			exit;
		}
	}

	public function updatePic()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$admNo = $this->input->post('sAdmNo');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

				$check = false;
			} else {
				$check = true;
			}
		} else if ($type == STYPE) {
			if ($this->Token->checkStudentToken($token, $admNo) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$_FILES['file']['name'] = $_FILES['profilePic']['name'];
			$_FILES['file']['type'] = $_FILES['profilePic']['type'];
			$_FILES['file']['tmp_name'] = $_FILES['profilePic']['tmp_name'];
			$_FILES['file']['error'] = $_FILES['profilePic']['error'];
			$_FILES['file']['size'] = $_FILES['profilePic']['size'];

			date_default_timezone_set("Asia/Kolkata");

			if ($type == ATYPE) {
				$config['upload_path'] = './upload/profilePic/admin/';

			} elseif ($type == TTYPE) {
				$config['upload_path'] = './upload/profilePic/teacher/';

			} elseif ($type == STYPE) {
				$config['upload_path'] = './upload/profilePic/student/';

			}

			$config['allowed_types'] = 'gif|jpg|png|jpeg';
			$config['remove_spaces'] = TRUE;
			$config['encrypt_name'] = TRUE;

			$this->load->library('upload', $config);
			$this->upload->initialize($config);

			if (!is_dir($config['upload_path'])) {
				mkdir($config['upload_path'], 0777, TRUE);
			}

			if (file_exists($config['upload_path'] . $_FILES['file']['name'])) {

				unlink($config['upload_path'] . $_FILES['file']['name']);

			}

			if ($this->upload->do_upload('file')) {
				// Uploaded file data
				$upload_data = $this->upload->data();

				if ($type == ATYPE) {
					$profilePic = $data['aProfilePic'] = $upload_data['file_name'];

				} elseif ($type == TTYPE) {
					$profilePic = $data['tProfilePic'] = $upload_data['file_name'];

				} elseif ($type == STYPE) {
					$profilePic = $data['sProfilePic'] = $upload_data['file_name'];

				}

			}

			if ($type == ATYPE) {
				$data['auDate'] = date("Y-m-d h:i:s");
				$where = array("aUsName" => $aUsName);
				$result = $this->Model->update("admin", $data, $where);
			} elseif ($type == TTYPE) {
				$data['tuDate'] = date("Y-m-d h:i:s");
				$where = array("tUsName" => $tUsName);
				$result = $this->Model->update("teacher", $data, $where);
			} elseif ($type == STYPE) {
				$data['suDate'] = date("Y-m-d h:i:s");
				$where = array("sAdmNo" => $admNo);
				$result = $this->Model->update("student", $data, $where);
			}

			if ($result) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Profile pic updated successfully",
					'profilePic' => $profilePic
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable update profile pic"

				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;
		}
	}

	public function chngPwd()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$aUsName = $this->input->post('aUsName');
		$tUsName = $this->input->post('tUsName');
		$admNo = $this->input->post('sAdmNo');
		$type = $this->input->post('type');

		if ($type == ATYPE) {
			if ($this->Token->checkAdminToken($token, $aUsName) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

				$check = false;
			} else {
				$check = true;
			}
		} else if ($type == STYPE) {
			if ($this->Token->checkStudentToken($token, $admNo) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			if ($type == ATYPE) {
				$where = array("aUsName" => $aUsName, "aPwd" => sha1($this->input->post('oPwd')));
				$this->db->where($where);
				$query = $this->db->get('admin');

			} elseif ($type == TTYPE) {
				$where = array("tUsName" => $tUsName, "tPwd" => sha1($this->input->post('oPwd')));
				$this->db->where($where);
				$query = $this->db->get('teacher');

			} elseif ($type == STYPE) {
				$where = array("sAdmNo" => $admNo, "sPwd" => sha1($this->input->post('oPwd')));
				$this->db->where($where);
				$query = $this->db->get('student');

			}

			$count_row = $query->num_rows();

			if ($count_row == 1) {

				if ($type == ATYPE) {
					$where = array("aUsName" => $aUsName);
					$data['aPwd'] = sha1($this->input->post('aPwd'));
					$updatePwd = $this->Model->update('admin', $data, $where);

				} elseif ($type == TTYPE) {
					$where = array("tUsName" => $tUsName);
					$data['tPwd'] = sha1($this->input->post('tPwd'));
					$updatePwd = $this->Model->update('teacher', $data, $where);

				} elseif ($type == STYPE) {
					$where = array("sAdmNo" => $admNo);
					$data['sPwd'] = sha1($this->input->post('sPwd'));
					$updatePwd = $this->Model->update('student', $data, $where);

				}

				if ($this->db->affected_rows() == 1) {
					$response = array(
						'responsecode' => '200',
						'status' => 'Success',
						'message' => "Password Updated Successfully",

					);
				} else {
					$response = array(
						'responsecode' => '200',
						'status' => 'fail',
						'message' => "Password Could not be updated",

					);
				}
			} else {

				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Password Incorrect",

				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;
		}
	}

	public function versionCheck()
	{
		if ($this->input->get_request_header('APP-PUBLIC-TOKEN', TRUE) != APP_PUBLIC_TOKEN) {

			$response = array(
				'responsecode' => '401',
				'status' => '0',
				'message' => 'Access Token is Invalid or Missing');

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}

		if ($_SERVER['REQUEST_METHOD'] == "POST") {

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => 'version found',
				'version' => '1.0.0');

		} else {
			$response = array(
				'responsecode' => '200',
				'status' => 'fail',
				'message' => 'Invalid request to url!');
		}

		/* Output header */
		/* 	header('Content-type: application/json');
		echo json_encode($json); */
		$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
		exit;

	}

}
