<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Teacher extends CI_Controller
{

	public function __construct()
	{
		parent:: __construct();
		$this->load->Model('Model');
		$this->load->Model('Token');
	}

	public function login()
	{
		if ($this->input->get_request_header('APP-PUBLIC-TOKEN', true) != APP_PUBLIC_TOKEN) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}

		$data['tUsName'] = $this->input->post('tUsName');
		$data['tPwd'] = sha1($this->input->post('tPwd'));

		$where = array("tUsName" => $data['tUsName'], "tPwd" => $data['tPwd']);
		$this->db->where($where);
		$query = $this->db->get('teacher');
		$count_row = $query->num_rows();

		if ($count_row != 1 || $count_row == 0) {

			$response = array(
				'responsecode' => '200',
				'status' => 'fail',
				'message' => "User not registered"
			);

		} else {
			$teacherData = $query->row_array();

			$tokenData['tToken'] = sha1(random_string('md5', 100));

			date_default_timezone_set("Asia/Kolkata");
			$tokenData['tuDate'] = date("Y-m-d h:i:s");
			$tokenData['tFcmId'] = $this->input->post('tFcmId');

			$this->db->where('tUsName', $teacherData['tUsName']);
			$this->db->update('teacher', $tokenData);

			if ($this->db->affected_rows() != 1) {

				//print_r($this->db->affected_rows());
				$response = array(
					'responsecode' => '200',
					'status' => 'tokenerror',
					'message' => "Unable to process request token"
				);

			} elseif ($this->db->affected_rows() == 1) {

				$teacherData['tFcmId'] = $tokenData['tFcmId'];
				$teacherData['tToken'] = $tokenData['tToken'];
				$teacherData['tuDate'] = $tokenData['tuDate'];
				$teacherData['tPwd'] = "";

//				echo '<pre>';
//				print_r($tokenData);

				$response = array(
					'responsecode' => '200',
					'status' => 'token-created',
					'message' => "Access token generated successfully",
					'teacherDetail' => $teacherData
				);

			}

		}

		$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')
			->set_header('Cache-Control: post-check=0, pre-check=0')
			->set_header('Pragma: no-cache')->set_status_header(200)
			->set_content_type('application/json', 'utf-8')
			->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
		exit;

	}

	public function getStudent()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$tUsName = $this->input->post('tUsName');

		if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['stFk'] = $this->input->post('stFk');
			$data['dvFk'] = $this->input->post('dvFk');

			$where = array("sActive" => '1', "stFk" => $data['stFk'], "dvFk" => $data['dvFk']);
			$data['student'] = $this->Model->join_where("student", "parents", ' `parents`.`sFk` = `student`.`sAdmNo` ', $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'student' => $data['student']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getTimeTable()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$tUsName = $this->input->post('tUsName');

		if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['stFk'] = $this->input->post('stFk');
			$data['dvFk'] = $this->input->post('dvFk');

			$where = array("ttActive" => '1', "tstFk" => $data['stFk'], "tdvFk" => $data['dvFk']);
			$data['timetable'] = $this->Model->join_three_where("timetable", "teacher", "subject", ' `timetable`.`tFk` = `teacher`.`tUsName` ', ' `timetable`.`sbFk` = `subject`.`sbId` ', $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'timetable' => $data['timetable']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addAttendance()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$tUsName = $this->input->post('tUsName');

		if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['tFk'] = $this->input->post('tUsName');
			$data['dvFk'] = $this->input->post('dvFk');

			date_default_timezone_set("Asia/Kolkata");
			$data['atcDate'] = date("Y-m-d");

			$attd = $this->input->post('atdList[]');
			$attendance = json_decode($attd);
			$value = array();

			foreach ($attendance as $res) {
				array_push($value, array(
					"tchrFk" => $data['tFk'],
					"atcDate" => $data['atcDate'],
					"atAttend" => $res->atAttend,
					"stdFk" => $res->stFk,
					"divFk" => $data['dvFk'],
					"sFk" => $res->sAdmNo
				));
			}

			$insert = $this->Model->insert_batch('attendance', $value);

			if ($insert) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Attendance added successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to add attendance."
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getAttendance()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$tUsName = $this->input->post('tUsName');

		if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['sFk'] = $this->input->post('sFk');
			$data['stFk'] = $this->input->post('stFk');
			$data['dvFk'] = $this->input->post('dvFk');
			$data['atdStDate'] = $this->input->post('atdStDate');
			$data['atdEndDate'] = $this->input->post('atdEndDate');

			$where = array("sFk" => $data['sFk'], "stdFk" => $data['stFk'], "divFk" => $data['dvFk']);
			$data['attendance'] = $this->Model->join_five_where_between_desc('`attendance`.`sFk` = `s`.`sAdmNo`', '`attendance`.`stdFk` = `std`.`stId`', '`attendance`.`divFk` = `div`.`dId`', '`attendance`.`tchrFk` = `tchr`.`tUsName`', $data['atdStDate'], $data['atdEndDate'], $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'attendance' => $data['attendance']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addAssignment()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			if (!empty($_FILES['asDoc']['name'])) {

				$_FILES['file']['name'] = $_FILES['asDoc']['name'];
				$_FILES['file']['type'] = $_FILES['asDoc']['type'];
				$_FILES['file']['tmp_name'] = $_FILES['asDoc']['tmp_name'];
				$_FILES['file']['error'] = $_FILES['asDoc']['error'];
				$_FILES['file']['size'] = $_FILES['asDoc']['size'];

				$config['upload_path'] = './upload/assignment/';

				$config['allowed_types'] = $config['allowed_types'] = 'pdf|pptx|ppt|xlsx|xls|docx|doc|txt|jpeg|jpg|png';;
				$config['remove_spaces'] = TRUE;
				$config['encrypt_name'] = TRUE;

				$this->load->library('upload', $config);
				$this->upload->initialize($config);

				if (!is_dir($config['upload_path'])) {
					mkdir($config['upload_path'], 0777, TRUE);
				}

				if (file_exists($config['upload_path'] . $_FILES['file']['name'])) {

					unlink($config['upload_path'] . $_FILES['file']['name']);

				}

				if ($this->upload->do_upload('file')) {
					// Uploaded file data
					$upload_data = $this->upload->data();

					$data['asDoc'] = $upload_data['file_name'];

				}

			}

			$data['astFk'] = $this->input->post('tUsName');
			$data['asscFk'] = $this->input->post('scFk');
			$data['asstFk'] = $this->input->post('stFk');
			$data['asdvFk'] = $this->input->post('dvFk');
			$data['assubFk'] = $this->input->post('sbFk');
			$data['asDesc'] = $this->input->post('asDesc');

			date_default_timezone_set("Asia/Kolkata");

			if ($type == UTYPE) {
				$data['asId'] = $this->input->post('asId');
				$data['asuDate'] = date("d-m-yy");
				$where = array("asId" => $data['asId']);
				$insert = $this->Model->update("assignment", $data, $where);
			} else {
				$data['ascDate'] = date("d-m-yy");
				$data['asuDate'] = $data['ascDate'];
				$insert = $this->Model->insert('assignment', $data);
			}

			if ($insert) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Assignment " . $type . " successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to " . $type . " Assignment."
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getSubTchrAssnt()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$tUsName = $this->input->post('tUsName');

		if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$where = array("tFk" => $tUsName);
			$data['assignteacher'] = $this->Model->join_four_where("assignteacher", "standard", "division", "subject", '`assignteacher`.`asgnStd` = `standard`.`stId`', '`assignteacher`.`asgnDiv` = `division`.`dId`', '`assignteacher`.`asgnSub` = `subject`.`sbId`', $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'assignteacher' => $data['assignteacher']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getAllAssignment()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$tUsName = $this->input->post('tUsName');

		if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$limit = $this->input->post('limit');
			$offset = $this->input->post('offset');

			$where = array("astFk" => $tUsName);
			$data['assignment'] = $this->Model->join_four_where_order_limit("assignment", "standard", "division", "subject", '`assignment`.`asstFk` = `standard`.`stId`', '`assignment`.`asdvFk` = `division`.`dId`', '`assignment`.`assubFk` = `subject`.`sbId`', $where, 'ascDate', 'desc', $limit, $offset);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'assignment' => $data['assignment']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getAssignmentDetail()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$admNo = $this->input->post('sAdmNo');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($type == STYPE) {
			if ($this->Token->checkStudentToken($token, $admNo) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['asId'] = $this->input->post('asId');

			$where = array("asId" => $data['asId']);
			$data['assignment'] = $this->Model->join_five_where_row("assignment", "standard", "division", "subject", "teacher", '`assignment`.`asstFk` = `standard`.`stId`', '`assignment`.`asdvFk` = `division`.`dId`', '`assignment`.`assubFk` = `subject`.`sbId`', '`assignment`.`astFk` = `teacher`.`tUsName`', $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'assignment' => $data['assignment']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addStudentActivity()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			if (!empty($_FILES['saDoc']['name'])) {

				$_FILES['file']['name'] = $_FILES['saDoc']['name'];
				$_FILES['file']['type'] = $_FILES['saDoc']['type'];
				$_FILES['file']['tmp_name'] = $_FILES['saDoc']['tmp_name'];
				$_FILES['file']['error'] = $_FILES['saDoc']['error'];
				$_FILES['file']['size'] = $_FILES['saDoc']['size'];

				$config['upload_path'] = './upload/studentactivity/';

				$config['allowed_types'] = $config['allowed_types'] = 'pdf|pptx|ppt|xlsx|xls|docx|doc|txt|jpeg|jpg|png';;
				$config['remove_spaces'] = TRUE;
				$config['encrypt_name'] = TRUE;

				$this->load->library('upload', $config);
				$this->upload->initialize($config);

				if (!is_dir($config['upload_path'])) {
					mkdir($config['upload_path'], 0777, TRUE);
				}

				if (file_exists($config['upload_path'] . $_FILES['file']['name'])) {

					unlink($config['upload_path'] . $_FILES['file']['name']);

				}

				if ($this->upload->do_upload('file')) {
					// Uploaded file data
					$upload_data = $this->upload->data();

					$data['saDoc'] = $upload_data['file_name'];

				}

			}

			$data['sascFk'] = $this->input->post('scFk');
			$data['sastFk'] = $this->input->post('stFk');
			$data['sadvFk'] = $this->input->post('dvFk');
			$data['satFk'] = $tUsName;
			$data['saTitle'] = $this->input->post('saTitle');
			$data['saDesc'] = $this->input->post('saDesc');

			date_default_timezone_set("Asia/Kolkata");

			if ($type == UTYPE) {
				$data['saId'] = $this->input->post('saId');
				$data['sauDate'] = date("d-m-yy");
				$where = array("saId" => $data['saId']);
				$insert = $this->Model->update("studentactivity", $data, $where);
			} else {
				$data['sacDate'] = date("d-m-yy");
				$data['sauDate'] = $data['sacDate'];
				$insert = $this->Model->insert('studentactivity', $data);
			}

			if ($insert) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Student activity " . $type . " successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to " . $type . " Student activity."
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getStdntAct()
	{
		$check = false;
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$admNo = $this->input->post('sAdmNo');
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($type == STYPE) {
			if ($this->Token->checkStudentToken($token, $admNo) == false) {

				$check = false;
			} else {

				$check = true;
			}
		} else if ($type == TTYPE) {
			if ($this->Token->checkTeacherToken($token, $tUsName) == false) {
				$check = false;
			} else {
				$check = true;
			}
		} else {
			$check = false;
		}
		if ($check == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['saId'] = $this->input->post('saId');

			$where = array("saId" => $data['saId']);
			$data['studentactivity'] = $this->Model->select_where_row("studentactivity", $where);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'studentactivity' => $data['studentactivity']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function getAllStdntAct()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$tUsName = $this->input->post('tUsName');

		if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$limit = $this->input->post('limit');
			$offset = $this->input->post('offset');

			$data['studentactivity'] = $this->Model->join_four_where_order_limit("studentactivity", "standard", "division", "teacher", '`studentactivity`.`sastFk` = `standard`.`stId`', '`studentactivity`.`sadvFk` = `division`.`dId`', '`studentactivity`.`satFk` = `teacher`.`tUsName`', 'sacDate', 'desc', $limit, $offset);

			$response = array(
				'responsecode' => '200',
				'status' => 'Success',
				'message' => "Get data successfully",
				'studentactivity' => $data['studentactivity']
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

	public function addResult()
	{
		$token = $this->input->get_request_header('APP-PRIVATE-TOKEN', TRUE);
		$tUsName = $this->input->post('tUsName');
		$type = $this->input->post('type');

		if ($this->Token->checkTeacherToken($token, $tUsName) == false) {

			$response = array(
				'responsecode' => '401',
				'status' => 'Unauthorised Access to Resources',
				'message' => 'Access Token is Invalid or Missing'
			);

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(401)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		} else {

			$data['rexFk'] = $this->input->post('rexFk');
			$data['rsFk'] = $this->input->post('rsFk');
			$data['rsbFk'] = $this->input->post('rsbFk');
			$data['rMark'] = $this->input->post('rMark');
			$data['rStatus'] = $this->input->post('rStatus');

			date_default_timezone_set("Asia/Kolkata");

			if ($type == UTYPE) {
				$data['rId'] = $this->input->post('rId');
				$where = array("saId" => $data['saId']);
				$insert = $this->Model->update("result", $data, $where);
			} else {
				$data['rcDate'] = date("d-m-yy");
				$insert = $this->Model->insert('result', $data);
			}

			if ($insert) {
				$response = array(
					'responsecode' => '200',
					'status' => 'Success',
					'message' => "Result " . $type . " successfully"
				);
			} else {
				$response = array(
					'responsecode' => '200',
					'status' => 'fail',
					'message' => "Unable to " . $type . " Student result."
				);
			}

			$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate')->set_header('Cache-Control: post-check=0, pre-check=0')->set_header('Pragma: no-cache')->set_status_header(200)->set_content_type('application/json', 'utf-8')->set_output(json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES))->_display();
			exit;

		}
	}

}
