<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Model extends CI_Model
{
	public function __construct()
	{
		parent:: __construct();
		$this->load->library('CurlRequest');
	}

	public function insert($table, $data)
	{
		return $this->db->insert($table, $data);
	}

	function insert_batch($table, $data)
	{
		return $this->db->insert_batch($table, $data);
	}

	public function update($table, $data, $where)
	{
		return $this->db->update($table, $data, $where);
	}

	public function delete($table, $where)
	{
		return $this->db->delete($table, $where);
	}

	public function select_all($table)
	{
		$this->db->select('*');
		$this->db->from($table);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join($table1, $table2, $con)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_order_limit($table1, $table2, $con, $field, $order, $limit, $offset)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con);
		$this->db->order_by($field, $order);
		$this->db->limit($limit);
		$this->db->offset($offset);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function select_where($table, $where)
	{
		$this->db->select('*');
		$this->db->from($table);
		$this->db->where($where);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function select_where_row($table, $where)
	{
		$this->db->select('*');
		$this->db->from($table);
		$this->db->where($where);

		$r = $this->db->get();
		return $r->row_array();
	}

	public function select_fcm_where($table, $where)
	{
		$this->db->select('uFcmId');
		$this->db->from($table);
		$this->db->where($where);

		$query = $this->db->get();
		return $query->row_array();
	}

	public function select_fcm($table)
	{
		$this->db->select('uFcmId');
		$this->db->from($table);

		$query = $this->db->get();
		return $query->row_array();
	}

	public function select_image($table, $where)
	{
		$this->db->select('plImage');
		$this->db->from($table);
		$this->db->where($where);

		$query = $this->db->get();
		return $query->row_array();
	}

	public function select_where_limit($table, $where, $limit, $offset)
	{
		$this->db->select('*');
		$this->db->from($table);
		$this->db->where($where);
		$this->db->limit($limit);
		$this->db->offset($offset);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function select_where_desc($table, $where)
	{
		$this->db->select('*');
		$this->db->from($table);
		$this->db->where($where);
		$this->db->order_by('qcDate', 'desc');

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function select_where_asc_limit($table, $where, $limit, $offset)
	{
		$this->db->select('*');
		$this->db->from($table);
		$this->db->where($where);
		$this->db->order_by('pPrice', 'asc');
		$this->db->limit($limit);
		$this->db->offset($offset);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function select_all_order($table, $field, $order)
	{
		$this->db->select('*');
		$this->db->from($table);
		$this->db->order_by($field, $order);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function select_where_desc_limit($table, $where, $limit, $offset)
	{
		$this->db->select('*');
		$this->db->from($table);
		$this->db->where($where);
		$this->db->order_by('pPrice', 'desc');
		$this->db->limit($limit);
		$this->db->offset($offset);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_three($table1, $table2, $table3, $con1, $con2)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con1);
		$this->db->join($table3, $con2);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_three_order_limit($table1, $table2, $table3, $con1, $con2, $field, $order, $limit, $offset)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con1);
		$this->db->join($table3, $con2);
		$this->db->order_by($field, $order);
		$this->db->limit($limit);
		$this->db->offset($offset);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_three_where($table1, $table2, $table3, $con1, $con2, $where)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con1);
		$this->db->join($table3, $con2);
		$this->db->where($where);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_three_where_row($table1, $table2, $table3, $con1, $con2, $where)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con1);
		$this->db->join($table3, $con2);
		$this->db->where($where);

		$r = $this->db->get();
		return $r->row_array();
	}

	public function join_three_limit($table1, $table2, $table3, $con1, $con2, $limit, $offset)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con1);
		$this->db->join($table3, $con2);
		$this->db->limit($limit);
		$this->db->offset($offset);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_where($table1, $table2, $con, $where)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con);
		$this->db->where($where);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_custom_where($con, $where)
	{
		$this->db->select('ast.asgnStd, ast.asgnDiv, ast.asgnSub, ast.tFk, tchr.tName');
		$this->db->from('assignteacher AS ast');
		$this->db->join('teacher AS tchr', $con);
		$this->db->where($where);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_where_order($table1, $table2, $con, $where, $field, $order)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con);
		$this->db->where($where);
		$this->db->order_by($field, $order);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_where_order_limit($table1, $table2, $con, $where, $field, $order, $limit, $offset)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con);
		$this->db->where($where);
		$this->db->order_by($field, $order);
		$this->db->limit($limit);
		$this->db->offset($offset);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_four_where($table1, $table2, $table3, $table4, $con1, $con2, $con3, $where)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con1);
		$this->db->join($table3, $con2);
		$this->db->join($table4, $con3);
		$this->db->where($where);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_four_where_limit($table1, $table2, $table3, $table4, $con1, $con2, $con3, $where, $limit, $offset)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con1);
		$this->db->join($table3, $con2);
		$this->db->join($table4, $con3);
		$this->db->where($where);
		$this->db->limit($limit);
		$this->db->offset($offset);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_four_where_order($table1, $table2, $table3, $table4, $con1, $con2, $con3, $where, $field, $order)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con1);
		$this->db->join($table3, $con2);
		$this->db->join($table4, $con3);
		$this->db->order_by($field, $order);
		$this->db->where($where);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_four_where_order_limit($table1, $table2, $table3, $table4, $con1, $con2, $con3, $where, $field, $order, $limit, $offset)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con1);
		$this->db->join($table3, $con2);
		$this->db->join($table4, $con3);
		$this->db->order_by($field, $order);
		$this->db->where($where);
		$this->db->limit($limit);
		$this->db->offset($offset);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_four_where_row($table1, $table2, $table3, $table4, $con1, $con2, $con3, $where)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con1);
		$this->db->join($table3, $con2);
		$this->db->join($table4, $con3);
		$this->db->where($where);

		$r = $this->db->get();
		return $r->row_array();
	}

	public function join_five_where($table1, $table2, $table3, $table4, $table5, $con1, $con2, $con3, $con4, $where)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con1);
		$this->db->join($table3, $con2);
		$this->db->join($table4, $con3);
		$this->db->join($table5, $con4);
		$this->db->where($where);

		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_five_where_between_desc($con1, $con2, $con3, $con4, $sDate, $eDate, $where)
	{

		$this->db->select('s.sName, s.sRoll, s.sAdmNo, s.sMob, tchr.tName, std.sStd, div.sdDiv, attendance.atAttend, attendance.atcDate');
		$this->db->from('attendance');
		$this->db->join('student AS s', $con1);
		$this->db->join('standard AS std', $con2);
		$this->db->join('division AS div', $con3);
		$this->db->join('teacher AS tchr', $con4);
		$this->db->where($where);
		$this->db->where('atcDate BETWEEN "' . date("Y-m-d", strtotime($sDate)) . " 00:00:00" . '" AND "' . date("Y-m-d", strtotime($eDate)) . " 23:59:59" . '"');
		$this->db->order_by('atId', 'desc');
		$r = $this->db->get();
		return $r = $r->result();
	}

	public function join_five_where_row($table1, $table2, $table3, $table4, $table5, $con1, $con2, $con3, $con4, $where)
	{
		$this->db->select('*');
		$this->db->from($table1);
		$this->db->join($table2, $con1);
		$this->db->join($table3, $con2);
		$this->db->join($table4, $con3);
		$this->db->join($table5, $con4);
		$this->db->where($where);

		$r = $this->db->get();
		return $r->row_array();
	}

	public function notification()
	{
		$id = $this->input->post('uId');
		$title = $this->input->post('title');
		$body = $this->input->post('body');
		$where = array('uId' => $id);

		$to = $this->Model->select_fcm('user', $where);

		$this->curlrequest->httpPost($to['uFcmId'], $title, $body);

	}

	public function approvedNotification($id, $title, $body)
	{
		$this->curlrequest->httpPost($id, $title, $body);
	}

	public function orderNotificationAdmin($title, $body)
	{

		$to = $this->Model->select_fcm('admin');

		$this->curlrequest->httpPost($to['uFcmId'], $title, $body);

	}

}
